---
title: AuthenticatorAttestationResponse.attestationObject
slug: Web/API/AuthenticatorAttestationResponse/attestationObject
tags:
  - API
  - AuthenticatorAttestationResponse
  - Property
  - Reference
  - Web Authentication API
  - WebAuthn
---
<p>{{APIRef("Web Authentication API")}}{{securecontext_header}}</p>

<p>The <code><strong>attestationObject</strong></code> property of the {{domxref("AuthenticatorAttestationResponse")}} interface returns an {{jsxref("ArrayBuffer")}} containing the new public key, as well as signature over the entire <code>attestationObject</code> with a private key that is stored in the authenticator when it is manufactured.</p>

<p>As part of the {{domxref("CredentialsContainer.create()")}} call, an authenticator will create a new keypair as well as an attestationObject for that keypair. The public key that corresponds to the private key that has created the attestation signature is well known; however, there are various well known attestation public key chains for different ecosystems (for example, Android or TPM attestations).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">attestObj = authenticatorAttestationResponse.attestationObject</pre>

<h2 id="Properties">Properties</h2>

<p>After decoding the <a href="https://tools.ietf.org/html/rfc7049">CBOR</a> encoded <code>ArrayBuffer</code>, the resulting JavaScript object will contain the following properties:</p>

<dl>
 <dt><code>authData</code></dt>
 <dd>The same as {{domxref("AuthenticatorAssertionResponse.authenticatorData")}}. Note that in {{domxref("AuthenticatorAssertionResponse")}}, the <code>authenticatorData</code> is exposed as a property in a JavaScript object while in {{domxref("AuthenticatorAttestationResponse")}}, the <code>authenticatorData</code> is a property in a <a href="https://tools.ietf.org/html/rfc7049">CBOR</a> map.</dd>
 <dd>The same {{domxref("AuthenticatorAssertionResponse.authenticatorData")}} field is used by both <code>AuthenticatorAttestationResponse</code> and by <code>AuthenticatorAssertionResponse</code>. When used in attestation, it contains an optional field, <code>attestedCredentialData</code>. This field is not included when used in the <code>AuthenticatorAssertionResponse</code>. The attestedCredentialData field contains the <code>credentialId</code> and <code>credentialPublicKey</code>.</dd>
 <dt><code>fmt</code></dt>
 <dd>A text string that indicates the format of the attStmt. The <a href="https://www.w3.org/TR/webauthn/#defined-attestation-formats">WebAuthn specification defines a number of formats</a>; however, formats may also be defined in other specifications and registered in an <a href="https://www.w3.org/TR/webauthn/#sctn-att-fmt-reg">IANA registry</a>. Formats defined by WebAuthn are:
 <ul>
  <li><code>"packed"</code></li>
  <li><code>"tpm"</code></li>
  <li><code>"android-key"</code></li>
  <li><code>"android-safetynet"</code></li>
  <li><code>"fido-u2f"</code></li>
  <li><code>"none"</code><span style="display: none;"> </span></li>
 </ul>
 </dd>
 <dt><code>attStmt</code></dt>
 <dd>A an attestation statement that is of the format defined by <code>"fmt"</code>. For now, <a href="https://www.w3.org/TR/webauthn/#defined-attestation-formats">see the WebAuthn specification for details on each format</a>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var publicKey = {
  challenge: /* from the server */,
  rp: {
    name: "Example CORP",
    id  : "login.example.com"
  },
  user: {
    id: new Uint8Array(16),
    name: "jdoe@example.com",
    displayName: "John Doe"
  },
  pubKeyCredParams: [
    {
      type: "public-key",
      alg: -7
    }
  ]
};

navigator.credentials.create({ publicKey })
  .then(function (newCredentialInfo) {
    var attestationObj = newCredentialInfo.response.attestationObject;
    // This will be a CBOR encoded ArrayBuffer

    // Do something with the response
    // (sending it back to the relying party server maybe?)
  }).catch(function (err) {
     console.error(err);
  });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebAuthn','#dom-authenticatorattestationresponse-attestationobject', 'attestationObject')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AuthenticatorAttestationResponse.attestationObject")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("PublicKeyCredentialCreationOptions.challenge")}}: the cryptographic challenge which signature by the authenticator is contained in <code>attStmt</code></li>
 <li>{{domxref("PublicKeyCredentialCreationOptions.attestation")}}: the attestation statement transport option specified for the creation</li>
</ul>
